# Comments release 1.0.0 by Steven Hartin
# ./addons/eventscripts/comments/comments.py

import es
import os
import langlib
import playerlib
import gamethread
import time
import services
import cPickle
import popuplib

import psyco
psyco.full()

dComments = {'totalComments':'0'}

info = es.AddonInfo()
info.name = 'Comments'
info.version = '1.2.2'
info.url = 'http://addons.eventscripts.com/addons/view/comments'
info.basename = 'comments'
info.author = 'Freddukes AKA Pro Noob'

es.ServerVar('comments', info.version, 'Comments Version - Made by Freddukes').makepublic()

def load():
    """
    Registers the commands, and loads up the strings.ini for langlib.
    Raises an error if there is no file.
    """
    global text
    global dComments
    global isAuthed
    
    if not es.exists('saycommand', '!box'):
        es.regsaycmd('!box', 'comments/comment_send', 'Command to start a new comment.')
    if not es.exists('clientcommand', '!box'):
        es.regclientcmd('!box', 'comments/comment_send', 'Command to start a new comment.')
    if not es.exists('clientcommand', 'box_send'):
        es.regclientcmd('box_send', 'comments/comment_sent')
    if not es.exists('saycommand', '!comments'):
        es.regsaycmd('!comments', 'comments/adminComments')
        
    str_path = es.getAddonPath('comments') + '/comments.db'
    if os.path.isfile(str_path):
        file_users = open(str_path)
        dComments = cPickle.load(file_users)
        file_users.close()
        es.dbgmsg(0,'Comments: Successfully Loaded \'comments.db\'')
    else:
        es.dbgmsg(0,'Comments: ERROR - No comments.db found! Creating one now.')
        
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('comment_reading', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'comment_reading')
    else:
        isAuthed = lambda x: False
        
    langPath = es.getAddonPath('comments') + '/strings.ini'
    if os.path.isfile(langPath):
        text = langlib.Strings(langPath)
    else:
        es.dbgmsg(0,'Comments: - ERROR Unable to load strings.ini! Please ensure it is in the ./comments/ directory.')
    if not text:
        text = 'Missing Language'
        
def round_start(ev):
    for player in es.getUseridList():
        es.tell(player, '#multi', text('advert', {}, playerlib.getPlayer(player).get('lang')))
        
def adminComments():
    userid = es.getcmduserid()
    if isAuthed(userid):
        cp = popuplib.easymenu("comments", "comments_choice", DetailedView)
        cp.settitle('[Server Comments]\nTotal Comments: %s\n    Page: '%(dComments['totalComments']))
        sDict = sorted(dComments, reverse=True)
        for comment in sDict:
            key = dComments[comment]
            if isinstance(key, dict) and key.has_key('shortcomment'):
                cp.addoption(comment, dComments[comment]['shortcomment'])
            if len(dComments) == 1:
                cp.addoption(None, "No comments yet...", False)
        popuplib.send('comments', userid)
        
def DetailedView(userid, choice, popupid):
    dDict = dComments[choice]
    popup = popuplib.create("detailed_comments")
    a = popup.addline
    a('Comment number %s'%choice)
    a('------------------------')
    a('Received: %s'%dDict['date'])
    a('      From: %s (%s)'%(dDict['name'], dDict['steamid']))
    a(' ')
    comment = dDict['fullcomment']
    for line in comment.split('\n'):
        a(line)
    a(' ')
    a('------------------------')
    a('0. Back')
    popup.submenu(10, 'comments')
    popuplib.send('detailed_comments',userid)
        
def comment_send():
    """
    Send an escape input box to the user to input his/her comment
    """
    userid = es.getcmduserid()
    es.tell(userid, '#multi', text('insert comments', {}, playerlib.getPlayer(userid).get('lang')))
    es.escinputbox(60, userid, '=== Comments ===', 'Enter a comment', 'box_send')
    
def comment_sent():
    """
    Retrieve Steamid and Name. Load up the comments.txt, then write the lines
    """
    userid  = es.getcmduserid()
    comment = es.getargs()
    steamid = es.getplayersteamid(userid)
    name    = es.getplayername(userid)
    myDate  = time.strftime('%A %d %B %y - %H:%M:%S %Z')
    
    total = int(dComments['totalComments'])
    total += 1
    dComments['totalComments'] = str(total)
    dComments[total] = {}
    if len(comment) > 30:
        dComments[total]['shortcomment'] = comment[:27] + '...'
    else:
        dComments[total]['shortcomment'] = comment
    dComments[total]['fullcomment']  = ''
    dComments[total]['name']         = name
    dComments[total]['date']         = myDate
    dComments[total]['steamid']      = steamid
    
    if len(name) > 29:
        name = name[0:28]
    else:
        while len(name) < 29:
            name += ' '
    
    comment = comment.split()
    temp_string = ''
    temp_line = ''
    while len(comment):
        if len(comment[0]) > 44: return
        temp_string_2 = temp_string + comment[0] + ' '
        temp_line_2 = temp_line + comment[0] + ' '
        if len(temp_line_2) < 46:
            temp_line = temp_line_2
            temp_string = temp_string_2
            dComments[total]['fullcomment'] += comment[0] + ' '
            comment.remove(comment[0])
        else:
            while len(temp_line) < 45:
                temp_string += ' '
                temp_line += ' '
            temp_string += '|\n|    '
            temp_line = ''
            dComments[total]['fullcomment'] += '\n'
    while len(temp_line) < 45:
        temp_line += ' '
        temp_string += ' '
    temp_string += '|'
            
    if len(myDate) > 49:
        myDate = myDate[0:48]
    else:
        while len(myDate) < 49:
            myDate += ' '
            
    strPath = es.getAddonPath('comments') + '/comments.txt'
    if not os.path.isfile(strPath):
        file(strPath, 'wt')
    commentsFile = open(strPath, 'a')
    comments = """|-------------------------------------------------|
|%s|
|-------------------------------------------------|
|    SteamID:       |            Name:            |
|-------------------|-----------------------------|
|%s |%s|
|-------------------------------------------------|
|Comment:                                         |
|    %s
|-------------------------------------------------|

"""

    commentsFile.writelines(comments%(myDate, steamid, name, temp_string))
    commentsFile.close()
    
    filepath = open(es.getAddonPath('comments') + '/comments.db', 'w')
    cPickle.dump(dComments, filepath)
    filepath.close()
    
    es.tell(userid, '#multi', text('comment sent', {}, playerlib.getPlayer(userid).get('lang')))
